HDOJ 1372 Knight Moves(BFS 廣搜)

題目:

Knight Moves

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3684    Accepted Submission(s): 2293


Problem Description
A friend of you is doing research on the Traveling Knight Problem (TKP) where you are to find the shortest closed tour of knight moves that visits each square of a given set of n squares on a chessboard exactly once. He thinks that the most difficult part of the problem is determining the smallest number of knight moves between two given squares and that, once you have accomplished this, finding the tour would be easy.
Of course you know that it is vice versa. So you offer him to write a program that solves the "difficult" part.

Your job is to write a program that takes two squares a and b as input and then determines the number of knight moves on a shortest route from a to b.


 

Input
The input file will contain one or more test cases. Each test case consists of one line containing two squares separated by one space. A square is a string consisting of a letter (a-h) representing the column and a digit (1-8) representing the row on the chessboard.


 

Output
For each test case, print one line saying "To get from xx to yy takes n knight moves.".


 

Sample Input
e2 e4 a1 b2 b2 c3 a1 h8 a1 h7 h8 a1 b1 c3 f6 f6


 

Sample Output
To get from e2 to e4 takes 2 knight moves. To get from a1 to b2 takes 4 knight moves. To get from b2 to c3 takes 2 knight moves. To get from a1 to h8 takes 6 knight moves. To get from a1 to h7 takes 5 knight moves. To get from h8 to a1 takes 6 knight moves. To get from b1 to c3 takes 1 knight moves. To get from f6 to f6 takes 0 knight moves.

 

 

題目鏈接:

http://acm.hdu.edu.cn/showproblem.php?pid=1372

 

 

題意:

  一個8*8的正方形棋盤,行用a-h標記,列用1-8標記。

  給定兩個座標,要求你從一個座標到另一個座標的最小步數。

  移動和象棋中的馬一樣,走 “日”  字。

 

思路:

廣搜8個方向

 

#include<iostream>
#include<queue>
using namespace std;

const int maxn = 10 +1;
int dir[8][2] = {-1,-2,1,-2,-1,2,1,2,-2,-1,-2,1,2,-1,2,1};
int used[maxn][maxn];
char a,b;
int x,y;


struct node
{
	int x;
	int y;
	int t;
};


void bfs()
{
	queue<node> q;
	node start;
	start.x = a - 'a' + 1;
	start.y = x;
	start.t = 0;
	q.push(start);
	used[start.x][start.y] = 1;
/*	if(a = b && x == y)
	{
		cout<<"0 knight moves."<<endl;
	}
	@@@@*/
	while(!q.empty())
	{
		node head = q.front();
		q.pop();
		if(head.x == b-'a'+1 && head.y == y)    //結束條件  因爲之前在for循環裏面  所以用 if(New.x == b-'a'+1 && New.y == y)  造成錯誤                      
		{
			cout<<head.t<<" knight moves."<<endl;
			return;
		}
		for(int i=0; i<8; i++)
		{
			node New;
			New=head;
			New.x = head.x + dir[i][0];
			New.y = head.y + dir[i][1];
			New.t = head.t + 1;			//計算走過的路徑  把計數器定在結構體裏面  不會造成計數重複 錯誤
			if(New.x>0 && New.x<=8 && New.y>0 && New.y<=8)//範圍這裏之前因爲start.x = a - 'a' + 1;沒有+1,導致範圍錯誤(豎的從0開始,橫的從1開始)
			{
				
				if(!used[New.x][New.y])
				{
			
				/*	if(New.x == b-'a'+1 && New.y == y)   
					{
						cout<<New.t<<" knight moves."<<endl;
						return;
					}*///如果是用這種做結束條件  要上面的那條語句@@@@,因爲起點和終點一樣的時候,在這裏已經是被擴展過的所以計數爲2
					used[New.x][New.y] = 1;
					q.push(New);
				
				}
			}
		
			
		}
	}
}

int main()
{
	
	while(cin>>a>>x>>b>>y)
	{
		memset(used, 0, sizeof(used));
		cout<<"To get from "<<a<<x<<" to "<<b<<y<<" takes ";
		bfs();
	}
	return 0;
}


//


 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章